<template>
    <div>
        <!-- Botón que abre el modal -->
        <v-btn
        id="toggle-btn-{{scheduleId}}"
        color="error"
        variant="text"
        class="btn-icon"
        @click="dialog = true"
        >
        <feather-icon icon="ArchiveIcon" />
        </v-btn>

        <!-- Modal (v-dialog) -->
        <v-dialog v-model="dialog" max-width="500px" persistent @click:outside="resetModalAndClose">
        <v-card>
            <v-card-title>Delete schedule</v-card-title>
            <v-card-text>
            <div v-if="isError" class="error-message">
                {{ errorMessage }}
            </div>
            <div v-else>
                Are you sure you want to delete this schedule?
            </div>
            </v-card-text>
            <v-card-actions>
            <v-spacer />
            <v-btn text color="secondary" @click="resetModalAndClose">Cancel</v-btn>
            <v-btn text color="error" @click="handleOk">Delete</v-btn>
            </v-card-actions>
        </v-card>
        </v-dialog>
    </div>
</template>
  
<script setup lang="ts">
import GitApiCall from '@/api/gitApi';
import { ref } from 'vue';
  
  // Definición de Props
  interface Props {
    projectId: number;
    scheduleId: number;
  }
  const props = defineProps<Props>();
  
  // Definición de eventos emitidos
  const emit = defineEmits<{ (e: 'finished'): void }>();
  
  // Estado local
  const dialog = ref(false);
  const isError = ref(false);
  const errorMessage = ref('');
  const saving = ref(false);
  const isRequest = ref(false);
  const requestMessage = ref('');
  
  // Funciones
  function resetModal() {
    isError.value = false;
    errorMessage.value = '';
  }
  
  function resetModalAndClose() {
    resetModal();
    dialog.value = false;
  }
  
  async function handleOk() {
    // Impide que se cierre el modal automáticamente y ejecuta la eliminación
    await handleSubmit();
  }
  
  async function handleSubmit() {
    await deleteSchedule();
    dialog.value = false;
  }
  
  async function deleteSchedule() {
    console.info('INFO: deleteSchedule');
    saving.value = true;
    const git = new GitApiCall();
    try {
      const response = await git.deleteSchedulePipeline(props.projectId, props.scheduleId);
      console.log('deleteSchedule response:', response.data);
      isError.value = false;
      emit('finished');
    } catch (error: any) {
      console.error('error deleteSchedule:', error);
      errorMessage.value = error.response?.data?.message || 'An error occurred';
      isError.value = true;
    }
    saving.value = false;
    isRequest.value = true;
  }
  </script>
  
  <style scoped>
  .btn-icon {
    /* Puedes agregar estilos adicionales para el botón si lo necesitas */
  }
  </style>
  